<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CS 250 Data Structures: Utilities/Menu.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CS 250 Data Structures
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_b05a5fa85f84bfc9013183c9d87f9a36.html">Utilities</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Menu.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Menu_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef _MENU</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define _MENU</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// C++ Library includes</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;iomanip&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;cstdlib&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;limits&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceUtility.html">Utility</a></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="classUtility_1_1Menu.html">   18</a></span>&#160;<span class="keyword">class </span><a class="code" href="classUtility_1_1Menu.html">Menu</a></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;{</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="comment">// OUTPUT</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classUtility_1_1Menu.html#a2ffde49104ac31636aacd5881d344399">Header</a>( <span class="keyword">const</span> std::string&amp; header );</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classUtility_1_1Menu.html#ac8659a825e319891adb5ac0a7d027daa">DrawHorizontalBar</a>( <span class="keywordtype">int</span> width, <span class="keywordtype">char</span> symbol = <span class="charliteral">&#39;-&#39;</span> );</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="comment">// MENUS and INPUT/OUTPUT</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classUtility_1_1Menu.html#af2c1148116944beeffef231e4b89064c">ShowMenu</a>( <span class="keyword">const</span> std::vector&lt;std::string&gt; options, <span class="keywordtype">bool</span> vertical = <span class="keyword">true</span>, <span class="keywordtype">bool</span> zeroToQuit = <span class="keyword">false</span> );</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code" href="classUtility_1_1Menu.html#a8d78de15b9c6c0635091774fce7e95ed">ShowIntMenuWithPrompt</a>( <span class="keyword">const</span> std::vector&lt;std::string&gt; options, <span class="keywordtype">bool</span> vertical = <span class="keyword">true</span>, <span class="keywordtype">bool</span> zeroToQuit = <span class="keyword">false</span> );</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classUtility_1_1Menu.html#a13e6c803193c62107089569f7d48181f">ShowStringMenuWithPrompt</a>( <span class="keyword">const</span> std::vector&lt;std::string&gt; options, <span class="keywordtype">bool</span> vertical = <span class="keyword">true</span> );</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keyword">static</span> std::function&lt;void(<span class="keywordtype">void</span>)&gt; <a class="code" href="classUtility_1_1Menu.html#aea0b3b7d4edd37a17b16a7e90b669bc8">ShowCallbackMenuWithPrompt</a>( std::map&lt;std::string, std::function&lt;<span class="keywordtype">void</span>(<span class="keywordtype">void</span>)&gt; &gt; options, <span class="keywordtype">bool</span> vertical = <span class="keyword">true</span> );</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code" href="classUtility_1_1Menu.html#aa64a0d8088c17210eace9daabb27479b">GetValidChoice</a>( <span class="keywordtype">int</span> min, <span class="keywordtype">int</span> max, <span class="keyword">const</span> std::string&amp; message = <span class="stringliteral">&quot;&quot;</span> );</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classUtility_1_1Menu.html#a40d0f1580535874745b43bf7e034897a">GetStringChoice</a>( <span class="keyword">const</span> std::string&amp; message = <span class="stringliteral">&quot;&quot;</span> );</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classUtility_1_1Menu.html#a610628ebafb3431002c834e5766b73cc">GetStringLine</a>( <span class="keyword">const</span> std::string&amp; message = <span class="stringliteral">&quot;&quot;</span> );</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code" href="classUtility_1_1Menu.html#af1fcfc8847de4197be79388552278103">GetIntChoice</a>( <span class="keyword">const</span> std::string&amp; message = <span class="stringliteral">&quot;&quot;</span> );</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt; <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classUtility_1_1Menu.html#ae0c4b1effadbca3526cb9946257adebe">DrawTable</a>( <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; headers, <span class="keyword">const</span> std::vector&lt;T&gt;&amp; data );</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="comment">// HANDY TRICKS</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classUtility_1_1Menu.html#a00bd35bf400e3ea5a82076b4dc00e5b7">ClearScreen</a>();</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classUtility_1_1Menu.html#a23e5562c06083baf1d8db1be65216117">Pause</a>();</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classUtility_1_1Menu.html#a4f8c64af47091e392ce727a9a3e1b38c">PrintPwd</a>();</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classUtility_1_1Menu.html#ac5a4bc55e4b9f6a4b60cab44ad8e408b">   42</a></span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classUtility_1_1Menu.html#ac5a4bc55e4b9f6a4b60cab44ad8e408b">s_lastCinWasStream</a>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classUtility_1_1Menu.html#ae0cd861ab6fcfca51d779e25d4c3de61">CinStreamString</a>();</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code" href="classUtility_1_1Menu.html#afbe245a5e66844d305119394c17eb368">CinStreamInt</a>();</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classUtility_1_1Menu.html#a18ac02eabb43284ca462c07e032daeba">CinGetlineString</a>();</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;};</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classUtility_1_1Menu.html#ae0c4b1effadbca3526cb9946257adebe">   50</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classUtility_1_1Menu.html#ae0c4b1effadbca3526cb9946257adebe">Utility::Menu::DrawTable</a>( <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; headers, <span class="keyword">const</span> std::vector&lt;T&gt;&amp; data )</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;{</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">int</span> totalColumns = data.size();</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">int</span> screenColumns = 80;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">int</span> blocksPerColumn = screenColumns / totalColumns;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordflow">if</span> ( headers.size() != 0 )</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    {</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordflow">for</span> ( <span class="keyword">auto</span>&amp; header : headers )</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            std::cout &lt;&lt; std::left &lt;&lt; std::setw( blocksPerColumn ) &lt;&lt; header;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        }</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        std::cout &lt;&lt; std::endl;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        DrawHorizontalBar( 80, <span class="charliteral">&#39;-&#39;</span> );</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    }</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">for</span> ( <span class="keyword">auto</span>&amp; dataItem : data )</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    {</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        std::cout &lt;&lt; std::left &lt;&lt; std::setw( blocksPerColumn ) &lt;&lt; dataItem;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    }</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    std::cout &lt;&lt; std::endl;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;}</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;} <span class="comment">// End of namespace</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespaceUtility_html"><div class="ttname"><a href="namespaceUtility.html">Utility</a></div><div class="ttdef"><b>Definition:</b> Logger.cpp:3</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_a8d78de15b9c6c0635091774fce7e95ed"><div class="ttname"><a href="classUtility_1_1Menu.html#a8d78de15b9c6c0635091774fce7e95ed">Utility::Menu::ShowIntMenuWithPrompt</a></div><div class="ttdeci">static int ShowIntMenuWithPrompt(const std::vector&lt; std::string &gt; options, bool vertical=true, bool zeroToQuit=false)</div><div class="ttdoc">Display a menu of options to the screen and get the user's selection, return as an integer.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:90</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_aa64a0d8088c17210eace9daabb27479b"><div class="ttname"><a href="classUtility_1_1Menu.html#aa64a0d8088c17210eace9daabb27479b">Utility::Menu::GetValidChoice</a></div><div class="ttdeci">static int GetValidChoice(int min, int max, const std::string &amp;message=&quot;&quot;)</div><div class="ttdoc">Ask the user to enter a number, ensures that number is between min and max before returning it.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:133</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_a18ac02eabb43284ca462c07e032daeba"><div class="ttname"><a href="classUtility_1_1Menu.html#a18ac02eabb43284ca462c07e032daeba">Utility::Menu::CinGetlineString</a></div><div class="ttdeci">static std::string CinGetlineString()</div><div class="ttdoc">Uses getline to get a string.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:31</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_a13e6c803193c62107089569f7d48181f"><div class="ttname"><a href="classUtility_1_1Menu.html#a13e6c803193c62107089569f7d48181f">Utility::Menu::ShowStringMenuWithPrompt</a></div><div class="ttdeci">static std::string ShowStringMenuWithPrompt(const std::vector&lt; std::string &gt; options, bool vertical=true)</div><div class="ttdoc">Display a menu of options to the screen and get the user's selection, return as a string.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:99</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_ae0cd861ab6fcfca51d779e25d4c3de61"><div class="ttname"><a href="classUtility_1_1Menu.html#ae0cd861ab6fcfca51d779e25d4c3de61">Utility::Menu::CinStreamString</a></div><div class="ttdeci">static std::string CinStreamString()</div><div class="ttdoc">Uses cin &gt;&gt; to get a string.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:9</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_af2c1148116944beeffef231e4b89064c"><div class="ttname"><a href="classUtility_1_1Menu.html#af2c1148116944beeffef231e4b89064c">Utility::Menu::ShowMenu</a></div><div class="ttdeci">static void ShowMenu(const std::vector&lt; std::string &gt; options, bool vertical=true, bool zeroToQuit=false)</div><div class="ttdoc">Display a menu to the screen, formatted nicely.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:62</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_a00bd35bf400e3ea5a82076b4dc00e5b7"><div class="ttname"><a href="classUtility_1_1Menu.html#a00bd35bf400e3ea5a82076b4dc00e5b7">Utility::Menu::ClearScreen</a></div><div class="ttdeci">static void ClearScreen()</div><div class="ttdoc">Clears the screen.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:195</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_a23e5562c06083baf1d8db1be65216117"><div class="ttname"><a href="classUtility_1_1Menu.html#a23e5562c06083baf1d8db1be65216117">Utility::Menu::Pause</a></div><div class="ttdeci">static void Pause()</div><div class="ttdoc">Supposed to ask the user to hit ENTER to continue but doesn't always work properly on every system.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:205</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_aea0b3b7d4edd37a17b16a7e90b669bc8"><div class="ttname"><a href="classUtility_1_1Menu.html#aea0b3b7d4edd37a17b16a7e90b669bc8">Utility::Menu::ShowCallbackMenuWithPrompt</a></div><div class="ttdeci">static std::function&lt; void(void)&gt; ShowCallbackMenuWithPrompt(std::map&lt; std::string, std::function&lt; void(void)&gt; &gt; options, bool vertical=true)</div><div class="ttdoc">Display a menu of options to the screen, a function pointer is returned as the result.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:117</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_ae0c4b1effadbca3526cb9946257adebe"><div class="ttname"><a href="classUtility_1_1Menu.html#ae0c4b1effadbca3526cb9946257adebe">Utility::Menu::DrawTable</a></div><div class="ttdeci">static void DrawTable(const std::vector&lt; std::string &gt; &amp;headers, const std::vector&lt; T &gt; &amp;data)</div><div class="ttdef"><b>Definition:</b> Menu.h:50</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_a40d0f1580535874745b43bf7e034897a"><div class="ttname"><a href="classUtility_1_1Menu.html#a40d0f1580535874745b43bf7e034897a">Utility::Menu::GetStringChoice</a></div><div class="ttdeci">static std::string GetStringChoice(const std::string &amp;message=&quot;&quot;)</div><div class="ttdoc">Asks the user to enter a string, returns the input.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:154</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_a2ffde49104ac31636aacd5881d344399"><div class="ttname"><a href="classUtility_1_1Menu.html#a2ffde49104ac31636aacd5881d344399">Utility::Menu::Header</a></div><div class="ttdeci">static void Header(const std::string &amp;header)</div><div class="ttdoc">Display an accented header.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:46</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html"><div class="ttname"><a href="classUtility_1_1Menu.html">Utility::Menu</a></div><div class="ttdoc">A class to help with CLI user interface formatting.</div><div class="ttdef"><b>Definition:</b> Menu.h:18</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_ac5a4bc55e4b9f6a4b60cab44ad8e408b"><div class="ttname"><a href="classUtility_1_1Menu.html#ac5a4bc55e4b9f6a4b60cab44ad8e408b">Utility::Menu::s_lastCinWasStream</a></div><div class="ttdeci">static bool s_lastCinWasStream</div><div class="ttdef"><b>Definition:</b> Menu.h:42</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_afbe245a5e66844d305119394c17eb368"><div class="ttname"><a href="classUtility_1_1Menu.html#afbe245a5e66844d305119394c17eb368">Utility::Menu::CinStreamInt</a></div><div class="ttdeci">static int CinStreamInt()</div><div class="ttdoc">Uses cin to get an integer.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:20</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_a610628ebafb3431002c834e5766b73cc"><div class="ttname"><a href="classUtility_1_1Menu.html#a610628ebafb3431002c834e5766b73cc">Utility::Menu::GetStringLine</a></div><div class="ttdeci">static std::string GetStringLine(const std::string &amp;message=&quot;&quot;)</div><div class="ttdoc">Asks the user to enter a string line, returns the input.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:168</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_af1fcfc8847de4197be79388552278103"><div class="ttname"><a href="classUtility_1_1Menu.html#af1fcfc8847de4197be79388552278103">Utility::Menu::GetIntChoice</a></div><div class="ttdeci">static int GetIntChoice(const std::string &amp;message=&quot;&quot;)</div><div class="ttdoc">Asks the user to enter an integer, returns the input.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:181</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_ac8659a825e319891adb5ac0a7d027daa"><div class="ttname"><a href="classUtility_1_1Menu.html#ac8659a825e319891adb5ac0a7d027daa">Utility::Menu::DrawHorizontalBar</a></div><div class="ttdeci">static void DrawHorizontalBar(int width, char symbol='-')</div><div class="ttdoc">Draw a horizontal rule.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:56</div></div>
<div class="ttc" id="aclassUtility_1_1Menu_html_a4f8c64af47091e392ce727a9a3e1b38c"><div class="ttname"><a href="classUtility_1_1Menu.html#a4f8c64af47091e392ce727a9a3e1b38c">Utility::Menu::PrintPwd</a></div><div class="ttdeci">static void PrintPwd()</div><div class="ttdoc">Prints the Present Working Directory.</div><div class="ttdef"><b>Definition:</b> Menu.cpp:223</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
